﻿@page "/"
@using System.Threading
@using System.Threading.Tasks
@using RoosterOil.Display.Data
@using RoosterOil.Shared
@using Microsoft.JSInterop

@inject NavigationManager uriHelper
@inject IJSRuntime JS
@inject DisplayService  DisplayServer
@using Microsoft.Extensions.Logging
@inject ILogger<Index> logger

@implements IDisposable

@if (contentData != null)
{
    if (contentData.itemType == ContentType.staticImage)
    {
        <StaticImage FullScreen=@fullScreen ImageFile=@contentData.locatorData
                     OffsetX=@canvasX OffsetY=@canvasY
                     Width=@itemWidth Height=@itemHeight
                     BackgroundImage=@backGroundImage BackgroundPaint=@backGroundPaint />
    }
    else if (contentData.itemType == ContentType.staticVideo)
    {
        <StaticVideo FullScreen=@fullScreen VideoFile=@contentData.locatorData
                     OffsetX=@canvasX OffsetY=@canvasY
                     Width=@itemWidth Height=@itemHeight
                     BackgroundImage=@backGroundImage BackgroundPaint=@backGroundPaint />
    }
    else if (contentData.itemType == ContentType.twitterTimeline)
    {
        <!--
            DO NOT REMOVE THE "<div> OF DEATH"
            For whatever reason, if you do not put the twitter-timeline in a <div></div>, the blazor rendered literally blows up.
            That's 4 hours of my life I'll never get back.  To make it more confusing, it blows up on the NEXT refresh.
            See: https://stackoverflow.com/questions/60183421/blazor-typeerror-cannot-read-property-removechild-of-null-at-object-e-as-rem
        -->
        <div>
            <a class="twitter-timeline" data-chrome="noborders noscrollbar noheader nofooter" href=@contentData.locatorData>@contentData.locatorInfo</a>
        </div>
    }
    else if (contentData.itemType == ContentType.blankPage)
    {
        <div></div>
    }
    else if (contentData.itemType == ContentType.messagePage)
    {
        <div class="logo">
            <div class="blankpage">
                @contentData.locatorData
            </div>
        </div>
    }
}

@code {
    private DisplayItem contentData;

    private int millisecondsToRun = 1000;

    private string canvasX = "0px";
    private string canvasY = "0px";
    private string itemWidth = "1920px";
    private string itemHeight = "1080px";
    private string backGroundImage = "";
    private string backGroundPaint = "";
    private bool fullScreen = true;

    private static Task backgroundRefresher;

    private CancellationTokenSource cts = new CancellationTokenSource();

    protected async Task ReRender()
    {
        try
        {
            logger.LogInformation("Re-rendering page.");
            if ((contentData?.itemType ?? ContentType.blankPage) == ContentType.twitterTimeline)
            {
                contentData = new DisplayItem()
                {
                    itemType = ContentType.blankPage
                };
                millisecondsToRun = 0;
            }
            else
            {
                contentData = await DisplayServer.GetNextDisplayItemAsync();

                fullScreen = (contentData.background == null);

                canvasX = contentData?.background?.canvasLocation?.X;
                canvasY = contentData?.background?.canvasLocation?.Y;
                itemWidth = contentData?.background?.displayAsSize?.Width;
                itemHeight = contentData?.background?.displayAsSize?.Height;
                backGroundImage = contentData?.background?.backgroundImage;
                backGroundPaint = contentData?.background?.backgroundPaint;

                millisecondsToRun = contentData.secondsToRun * 1000;
                logger.LogInformation($"Next content item is: {contentData.locatorData}.");
            }
            this.StateHasChanged();
        }
        catch (Exception ex)
        {
            logger.LogError(ex.Message);
        }
    }

    protected async Task RenderLoop()
    {
        while (!cts.IsCancellationRequested)
        {
            await InvokeAsync(ReRender);
            await Task.Delay(millisecondsToRun, cts.Token);
        }
    }

    protected override Task OnInitializedAsync()
    {
        if (backgroundRefresher == null)
        {
            logger.LogInformation("Starting refresh loop.");
            backgroundRefresher = Task.Run(RenderLoop, cts.Token);
        }
        else
        {
            logger.LogWarning("On initialized did NOT start refresh loop.");
        }
        return Task.CompletedTask;
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        try
        {
            if ((contentData?.itemType ?? ContentType.blankPage) == ContentType.twitterTimeline)
            {
                await JS.InvokeVoidAsync("twitterRefresh");
            }

            if (backgroundRefresher != null &&
                (backgroundRefresher.Status != TaskStatus.WaitingToRun && backgroundRefresher.Status != TaskStatus.WaitingForActivation && backgroundRefresher.Status != TaskStatus.Running) &&
                !cts.IsCancellationRequested)
            {
                logger.LogWarning("Render loop not running - restarting.");
                backgroundRefresher = Task.Run(RenderLoop, cts.Token);
            }

            await base.OnAfterRenderAsync(firstRender);
        }
        catch (Exception ex)
        {
            logger.LogError(ex.Message);
        }
    }

    public void Dispose()
    {
        logger.LogInformation("Requesting cancellation of all tasks.");
        cts.Cancel();
    }
}
